VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ImageList ImageList1 
      Left            =   480
      Top             =   240
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":0000
            Key             =   "UpArrow"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "Form1.frx":0452
            Key             =   "DownArrow"
         EndProperty
      EndProperty
   End
   Begin MSComctlLib.ListView ListView1 
      Height          =   1455
      Left            =   240
      TabIndex        =   0
      Top             =   1200
      Width           =   6255
      _ExtentX        =   11033
      _ExtentY        =   2566
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ColHdrIcons     =   "ImageList1"
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.Label Label1 
      Caption         =   "Click on one of the column headers to sort by that column"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   840
      Width           =   6255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub SortListView(ByRef List As ListView, ColHeadIndex As Integer)
    
    Dim lcv As Long     'Loop Control Variable
  
    With List
        ' Make sure the Sorted property is set to true
        .Sorted = True
        
        ' Sort according to the colum that was clicked (off by one)
        .SortKey = ColHeadIndex - 1
       
        ' Does the column already have an icon?
        If .ColumnHeaders(ColHeadIndex).Icon = 0 Then
            'No, So we will assume this column is not sorted
            
            ' Set to Ascending order
            .SortOrder = lvwAscending
            
            ' Set the ColumnHeader to be the Up Arrow
            .ColumnHeaders(ColHeadIndex).Icon = "UpArrow"
            
        ' Does the column have an UpArrow icon?
        ElseIf .ColumnHeaders(ColHeadIndex).Icon = "UpArrow" Then
            ' Yes, So the column is in Ascending order, switch to descending
            
            ' Set the Column Icon to the Down Arrow
            .ColumnHeaders(ColHeadIndex).Icon = "DownArrow"
            
            ' Set the sort order to descending
            .SortOrder = lvwDescending
        
        Else
            ' Otherwise sort into ascending order
        
            ' Set to Ascending order
            .SortOrder = lvwAscending
            
            ' Set the ColumnHeader to be the Up Arrow
            .ColumnHeaders(ColHeadIndex).Icon = "UpArrow"
        End If
       
        ' Remove any icon (presumably an arrow icon) from all other columns
        ' For every Column in the ListView Control...
        For lcv = 1 To List.ColumnHeaders.Count
            ' Is the current column the clicked column?
            If Not (lcv = ColHeadIndex) Then
                ' No, remove any icon it may have
                .ColumnHeaders(lcv).Icon = 0
            End If
        Next lcv
    
        ' Refresh the display of the ListView Control
        .Refresh
    End With
End Sub

Private Sub Form_Load()

    Dim itmX As ListItem ' Create a variable to add ListItem objects.
    Dim clmX As ColumnHeader ' Create an object variable for the ColumnHeader object.
   ' Add ColumnHeaders.
    Set clmX = ListView1.ColumnHeaders.Add(, , "Column 1", ListView1.Width / 3)
    Set clmX = ListView1.ColumnHeaders.Add(, , "Column 2", ListView1.Width / 3)
    Set clmX = ListView1.ColumnHeaders.Add(, , "Column 3", ListView1.Width / 3)
    
    ListView1.BorderStyle = ccFixedSingle ' Set BorderStyle property.
    ListView1.View = lvwReport ' Set View property to Report.
    
    ' Add a main item
    Set itmX = ListView1.ListItems.Add(, , "First value")
    ' Add two subitems for that item
    itmX.SubItems(1) = "First value subitem 1"
    itmX.SubItems(2) = "First value subitem 2"

    ' Add another main item
    Set itmX = ListView1.ListItems.Add(, , "Second value")
    ' Add two subitems for that item
    itmX.SubItems(1) = "Second value subitem 1"
    itmX.SubItems(2) = "Second value subitem 2"
    
    ' Add another main item
    Set itmX = ListView1.ListItems.Add(, , "Third value")
    ' Add two subitems for that item
    itmX.SubItems(1) = "Third value subitem 1"
    itmX.SubItems(2) = "Third value subitem 2"
    

End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
Call SortListView(ListView1, ColumnHeader.Index)
End Sub
